        Include "P16f818.inc"
;
;********************************************************************** 
        __config        _LVP_OFF & _CP_OFF & _BODEN_ON & _MCLR_OFF & _PWRTE_ON & _WDT_OFF & _HS_OSC & _DEBUG_OFF & _WRT_ENABLE_OFF & _CPD_OFF & _CCP1_RB3
                
			     
;-------------------------------------------
;       Port pin usage        
;-------------------------------------------
                                           
 ; Port A                                       Pin No.
        #define FWD_AD          PORTA,0         ;17
        #define REV_AD          PORTA,1         ;18
        ;#define 	        PORTA,2         ;1
        #define R_w             PORTA,3         ;2 Alternate use
        #define Rs              PORTA,4         ;3
        ;#define                PORTA,5         ;4
        ;#define 	        PORTA,6         ;15
        ;#define  	        PORTA,7         ;16

 ; Port B       
        #define Disp_En         PORTB,0         ;6
        ;#define      		PORTB,1         ;7
        #define LCD_Bit6        PORTB,2         ;8
        #define _VGen           PORTB,3         ;9 PWM
        #define Disp_D4         PORTB,4         ;10 - Top button
        #define Disp_D5         PORTB,5         ;11 - Middle button
        #define OscIn           PORTB,6         ;12
        #define Disp_D7         PORTB,7         ;13 - Bottom Button

        #define rp0             STATUS,RP0
;   
;-------------------------------------------
;       Constant Equates Table        
;-------------------------------------------
					
Func_set        equ     b'00101000'
Display_off     equ     b'00001000'
Display_on      equ     b'00001100'     ;cursor off (bit 2)
Clr_display     equ     b'00000001'
Shift_Left	equ	b'00010000'
Entry_inc       equ     b'00000110'
Dd_ram_addr     equ     b'10000000'
Line_One	equ	b'10000000'
Line_Two	equ	b'11000000'

Lcd_init_delay  equ     .255

Lcd_Port	equ     TRISB     
Lcd_Data        equ     PORTB

Portb_Out 	equ	b'01001111' 	;"and" with TRISB register
Portb_In	equ	b'10110000'	;"or" with TRISB register

;-------------------------------------------
;       File Equates Table        
;-------------------------------------------
        cblock 0X20
        FreqLow
        FreqHigh
        FreqUpper
        FWDHigh
        FWDLow
        REVHigh
        REVLow
        TMR1U
        StartupCounter
        Flags
        Temp
        Temp1
        Temp2
        R0		
        R1		
        R2
        R3
        ACC_a_0
        ACC_a_1
        ACC_b_0 		
        ACC_b_1
        ACC_b_2
        ACC_c_0
        ACC_c_1
        ACC_c_2
        ACC_d_0
        ACC_d_1
        ACC_d_2
        Buffer_0	
        Buffer_1	
        Buffer_2	
        Buffer_3	
        Buffer_4	
        Buffer_5	
        Buffer_6	
        Buffer_7	
        Char
        Lsd
        Msd
        Init_Disp_Delay
        Text_pointer
        LoopCount        
	Tmr0PostScale
 endc

;-------------------------------------------
;       File BIT Equates Table        
;-------------------------------------------
        #define ZeroFlag        Flags,0
        #define mult_carry      Flags,1

;-------------------------------------------
;       Macros        
;-------------------------------------------
BANK0   macro
        bcf     STATUS,RP0
        bcf     STATUS,RP1
        endm

;-------------------------------------------
;       Main code        
;-------------------------------------------
ResetVector
        org     0       
        goto    Initialise

;******************************************************************************
;	Text to be output to LCD module
;******************************************************************************
TextTable				;begining of text tables							
	movwf   PCL          		;jump to Char pointed to 
 
Text_Welcome_1
	dt	"LCD display demo",0
Text_Welcome_2
	dt	" radio-kits.com ",0
SWR 
	dt	"SWR ",0
NO_RF
	dt	"-No RF!-",0
Text_MHz
	dt	" MHz",0
Text_Freq
	dt	"F ",0

TextTableEnd
	if HIGH TextTable != HIGH TextTableEnd 
	error "Text Table breaks page boundary"
	endif
	;
;*****************************************************************************
Initialise
        ; Wait a while for the PSU to stabilise
        clrf    PORTA
        clrf    PORTB
        bsf     STATUS,RP0
        clrf    EECON1
        movlw   b'10100011'     ;
        movwf   TRISA           ; Set up port A
        movlw   b'11110000'
        movwf   TRISB           ; Set up port B
        movlw   b'10000111'     ; Set up timer 0
        movwf   OPTION_REG      ; Internal clock, prescaler assigned to timer 0
                                ; and prescaler set to 256
        movlw   0XFF            ; Setup timer 2 for PWM
        movwf   PR2
        bsf     PIE1,TMR1IE     ; Enable timer 1 interupt
        movlw   b'11001110'     ; b'11000100'Select A/D convertor input as RA0, A/D clock/2 and result right justified
        movwf   ADCON1
        bcf     STATUS,RP0
        movlw   b'00000111'
        movwf   T1CON           ; Set up timer 1 
        movlw   b'00000100'
        movwf   T2CON
        movlw   b'00001100'
        movwf   CCP1CON         ; Turn on PWM with xxxx11xx, lower PWM bits in 5-4
        movlw   b'01111111'
        movwf   CCPR1L          ; 
        ; Initialise A/D convertor module
        movlw   b'01000000'     ; Channel 0, A/D convertor running
        movwf   ADCON0	
        ; initialise display
        call    lcd_delay               ; Allow plenty of time for LCD to initialise
	call	Lcd_init		; Initialise LCD display
	movlw	Display_on		; Turn display on
	call	send_cmd
 ;       call    Welcome_Routine

;*****************************************************************************
Loop    
        clrf    TMR1L          
        clrf    TMR1H           
        clrf    TMR1U           ; Reload TMR1L, TIMR1H and pseudo timer TMR1U with 0
        bcf     PIR1,TMR1IF
        bsf     T1CON,TMR1ON    ; Enable counter(timer 1) 
        movlw   .255
        movwf   Temp
CounterDelayLoop
        btfsc   PIR1,TMR1IF     ; Check for timer 1 interupt
        goto    IncrementTMR1U
        nop			; Cycles to add delay to compensate TMR1U incrementation
        nop
        nop
        nop
        nop
CounterDelay1
        movlw   .243
        movwf   LoopCount
;	nop
;	nop
;	nop
;	nop
;	nop
;	nop
;	nop
;	nop
;	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
        decfsz  LoopCount,f
        goto    $-6             ; Loop until complete
        decfsz  Temp,f
        goto    CounterDelayLoop
	movlw	.47
	movwf	Temp
        nop
	decfsz  Temp,f
        goto    $-2             ; Loop until complete
	nop
	nop
	nop
	nop
	nop
;	nop
	nop
	nop
	nop
	nop
        bcf     T1CON,TMR1ON    ; Stop timer 1
        btfsc   PIR1,TMR1IF     ; Check for timer 1 interupt
        incf    TMR1U,f
        ;
Display
        call    DisplayFreq
        call    GetFwdAD
        call    GetRevAD
        call    CalcSWR
	call	DisplaySWR

        goto    Loop

IncrementTMR1U
        incf    TMR1U,f                 ; Increment upper byte of frequency count
        bcf     PIR1,TMR1IF
        goto    CounterDelay1

;******************************************************************************
Welcome_Routine
	movlw	.4
	movwf	Init_Disp_Delay	                ; Initialise startup display delay
	movlw	Clr_display
	call	send_cmd
	movlw   b'10000000'			; Sets ram address at 00h i.E. the start
	call    send_cmd
	movlw	Text_Welcome_1 - TextTable	; Point to message
	call	LCD_Out
	movlw   Line_Two			; First digit line 2
	call    send_cmd
	movlw	Text_Welcome_2 - TextTable	; Point to message
	call	LCD_Out
	return
	
;*****************************************************************************
GetFwdAD        
        movlw   b'01000001'     
        movwf   ADCON0	        ; Set to read AN0 (FWD power)
        call    ADDelay         ; Delay to charge sampling capacitor
        bcf     PIR1,ADIF
        bsf     ADCON0,GO       ; Start AD conversion
GetFwdADLoop
        btfss   PIR1,ADIF       ; Wait until finished
        goto    GetFwdADLoop
        movfw   ADRESH
        movwf   FWDHigh
        bsf     STATUS,RP0
        movfw   ADRESL
        bcf     STATUS,RP0
        movwf   FWDLow          ; Save in FWDHigh/Low
        return

;*****************************************************************************
GetRevAD
        call    ADDelay         ; Delay before next aquisition
        movlw   b'01001001'     
        movwf   ADCON0	        ; Set to read AN1 (REV power)
        call    ADDelay         ; Delay to charge sampling capacitor
        bcf     PIR1,ADIF
        bsf     ADCON0,GO       ; Start AD conversion
GetRevADLoop
        btfss   PIR1,ADIF       ; Wait until finished
        goto    GetRevADLoop
        movfw   ADRESH
        movwf   REVHigh
        bsf     STATUS,RP0
        movfw   ADRESL
        bcf     STATUS,RP0
        movwf   REVLow          ; Save in FWDHigh/Low
        return

;*****************************************************************************
CalcSWR         ; SWR = ((FWD+REV)*100)/(FWD-REV)
        movfw   REVLow
        addwf   FWDLow,w
        movwf   ACC_a_0  
        incf    REVHigh,w
        btfss   STATUS,C        
        movfw   REVHigh
        addwf   FWDHigh,w       
        movwf   ACC_a_1         ; FWD+REV 

        clrf    ACC_b_1         ; Result stored in ACC_a
        movlw   .100
        movwf   ACC_b_0
        call    D_mpy           ; Result x 100, result in ACC_b_1, ACC_b_0, ACC_c_1, ACC_c_0

        movfw   ACC_b_0
        movwf   ACC_b_2
        movfw   ACC_c_1
        movwf   ACC_b_1
        movfw   ACC_c_0
        movwf   ACC_b_0         ; Load appropriate pseudo accumulators ready for devision

        movfw   REVLow
        subwf   FWDLow,w
        movwf   ACC_a_0  
        incf    REVHigh,w
        btfsc   STATUS,C
        movfw   REVHigh
        subwf   FWDHigh,w       
        movwf   ACC_a_1         ; FWD-REV Result stored in ACC_c

        call    D_div           ; ((FWD+REV)*100)/(FWD-REV) result in ACC_b

        clrf    ACC_b_2
        call    B2_BCD          ; Convert binary result to BCD
        call    Expand_BCD      ; Convert packed BCD to ASCII
        return

;*****************************************************************************
DisplaySWR
	;	Set to line one, first character in
	movlw	b'10000000'
	call	send_cmd
	;
	movlw	SWR - TextTable	        ; Point to message
	call	LCD_Out
        ;
	;If AD result FWDlow < decimal 10 display "No RF"
	movlw	.10
	subwf	FWDLow,w
	btfss	STATUS,C
	goto	DisplaySWRNORF	
	;If character = 0 display " " (leading zero supression)
DisplaySWRHundreds
	movlw	"0"
	subwf	Buffer_2,w
	btfsc	STATUS,Z
	goto	DisplaySWRLeadingZero
	movfw	Buffer_2	
	call	send_char	; Display Hundreds
DisplaySWRTens
	movfw	Buffer_3	
	call	send_char	; Display Tens
DisplaySWRUnits	
	movfw	Buffer_4
	call	send_char	; Display Units
	movlw	"."	
	call	send_char	; Display Display "."
	movfw	Buffer_5
	call	send_char	; Display Tenths
	movfw	Buffer_6
	call	send_char	; Display Hundredths
	movlw	":"
	call	send_char	; Display  ":"
	movlw	"1"
	call	send_char	; Display  "1"
	movlw	" "
	call	send_char	; Display " "
	movlw	" "
	call	send_char	; Display " "
DisplaySWREnd
	return
	;
DisplaySWRLeadingZero
	movlw	" "
	call	send_char	; Display space in Hundreds
	movlw	"0"		; Test Tens for "0"
	subwf	Buffer_3,w
	btfss	STATUS,Z
	goto	DisplaySWRTens	; No zero so display Tens value
	movlw	" "	
	call	send_char	; Display space in Tens value
	goto	DisplaySWRUnits

DisplaySWRNORF
	movlw	NO_RF - TextTable	        ; Point to message
	call	LCD_Out	
	goto	DisplaySWREnd

;*****************************************************************************
DisplayFreq
	;	Set to line two, first character in
	movlw	b'11000000'
	call	send_cmd
	;
	movlw	Text_Freq - TextTable	        ; Point to message
	call	LCD_Out
        ;
	movfw	TMR1L
	movwf	ACC_b_0
        movfw   TMR1H
	movwf	ACC_b_1
        movfw   TMR1U
	movwf	ACC_b_2		;  

        clrf    ACC_a_1
        movlw   .2
        movwf   ACC_a_0

        call    D_div
        call	B2_BCD	
	call	Expand_BCD
	;
	movlw	"0"		; Check for leading zero
	subwf	Buffer_0,w
	btfss	STATUS,Z
	goto	DisplayFreq1
	movlw	" "		; Exists so send a "space"
	goto	DisplayFreq2
DisplayFreq1
	movfw	Buffer_0	; 10MHz
DisplayFreq2
	call	send_char	
	movfw	Buffer_1
	call	send_char	; 1MHz
	movlw	"."	
	call	send_char	; Display "."
	movfw	Buffer_2
	call	send_char	; 100kHz
	movfw	Buffer_3
	call	send_char	; 10kHz 
	movfw	Buffer_4
	call	send_char	; 1KHz
	movfw	Buffer_5
	call	send_char	; 100Hz
	movfw	Buffer_6
	call	send_char	; 10Hz
	;
	movlw	Text_MHz - TextTable
	call	LCD_Out
	return

;*****************************************************************************
ADDelay ; Approx 50uS delay at 10MHz clock
        movlw   .40
        movwf   LoopCount
        decfsz  LoopCount,f
        goto    $-1
        return

;*****************************************************************************
LCD_Out 
LCD_Out_loop
	movwf	Text_pointer
	movwf   Temp1           	;Temp1 holds start of message 
	movlw	LOW TextTable	        ;address
	addwf	Temp1,f		        ;add offset
	movlw	HIGH TextTable	
	btfsc	STATUS,C		;check if over page boundary
	addlw	1			;yes so inc high byte
	movwf	PCLATH
	movfw	Temp1
	call	TextTable
	andlw   0ffh   			;check if at end of message (zero
	btfsc   STATUS,Z	  	;returned at end)
	goto    LCD_Out_end         
	call    send_char		;display character
	movfw   Text_pointer		;point to next character
	addlw   1
	goto    LCD_Out_loop
LCD_Out_end
	return


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;		Modified from AN526
;********************************************************************
;                  Binary To BCD Conversion Routine
;      This routine converts a 24 Bit binary Number to a 7 Digit
; BCD Number. 
;       The 24 bit binary number is input in locations ACC_b_2,ACC_b_1 and
; ACC_b_0 with the high byte in ACC_b_2.
;       The 7 digit BCD number is returned in R0, R1, R2 and R3 with R0
; containing the MSD in its right most nibble.
;
;
;       Program:          B16TOBCD.ASM 
;
;*******************************************************************;
;
B2_BCD  bcf     STATUS,0 	; clear the carry bit
	movlw   .24
	movwf   Temp2
	clrf    R0
	clrf    R1
	clrf    R2
	clrf	R3
loop24  
	rlf     ACC_b_0, F
	rlf     ACC_b_1, F
	rlf     ACC_b_2, F
	rlf     R3, F
	rlf     R2, F
	rlf     R1, F
	rlf     R0, F
;
	decfsz  Temp2, F
	goto    adjDEC
	RETLW   0
;
adjDEC  
	movlw   R3
	movwf   FSR
	call    adjBCD
;
	movlw   R2
	movwf   FSR
	call    adjBCD
;
	movlw   R1
	movwf   FSR
	call    adjBCD
;
	movlw   R0
	movwf   FSR
	call    adjBCD
;
	goto    loop24
;
adjBCD  movlw   3
	addwf   0,W
	movwf   Temp1
	btfsc   Temp1,3	; test if result > 7
	movwf   0
	movlw   30
	addwf   0,W
	movwf   Temp1
	btfsc   Temp1,7 	; test if result > 7
	movwf   0              	; save as MSD
	retlw   0

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Expand_BCD
	movfw	R0
	addlw	h'30'		; Add ascii offset
	movwf	Buffer_0
;
	swapf	R1,w
	andlw	h'0f'		; Mask off lower nibble
	addlw	h'30'
	movwf	Buffer_1
;
	movfw	R1
	andlw	h'0f'		; Mask off lower nibble	
	addlw	h'30'
	movwf	Buffer_2
;
	swapf	R2,w
	andlw	h'0f'		; Mask off lower nibble
	addlw	h'30'
	movwf	Buffer_3
;
	movfw	R2
	andlw	h'0f'		; Mask off lower nibble	
	addlw	h'30'
	movwf	Buffer_4
;
	swapf	R3,w
	andlw	h'0f'		; Mask off lower nibble
	addlw	h'30'
	movwf	Buffer_5
;
	movfw	R3
	andlw	h'0f'		; Mask off lower nibble	
	addlw	h'30'
	movwf	Buffer_6
	return

;		Modified from AN526
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;*******************************************************************
;                       Double Precision Division
;
;               ( Optimized for Code Size : Looped Code )
;
;*******************************************************************;
;   Division : ACCb(24 bits) / ACCa(16 bits) -> ACCb(16 bits) with
;                                               Remainder in ACCc (16 bits)
;      (a) Load the Denominator in location ACC_a_1 & ACC_a_0 ( 16 bits )
;      (b) Load the Numerator in location 
;	  ACC_b_1 & ACC_b_0 & ACC_b_2 ( 24 bits )
;      (c) CALL D_div
;      (d) The 24 bit result is in location ACC_b_1 & ACC_b_0 & ACC_b_2
;      (e) The 16 bit Remainder is in locations ACC_c_1 & ACC_c_0
;
;*******************************************************************
;
D_div
;
		movlw   .24             ; for 24 shifts
		movwf   Temp1
		movfw	ACC_b_2
		movwf	ACC_d_2
		movfw   ACC_b_1	   	;move accb to accd
		movwf   ACC_d_1
		movfw   ACC_b_0
		movwf   ACC_d_0
		clrf	ACC_b_2
		clrf    ACC_b_1
		clrf    ACC_b_0
		clrf    ACC_c_1
		clrf    ACC_c_0
dloop 
		bcf     STATUS,C
		rlf     ACC_d_0,f
		rlf     ACC_d_1,f
		rlf	ACC_d_2,f
		rlf  	ACC_c_0,f
		rlf     ACC_c_1,f
		movfw   ACC_a_1
		subwf   ACC_c_1,w        ;check if a>c
		btfss   STATUS,Z
		goto    nochk
		movf    ACC_a_0,w
		subwf   ACC_c_0,w        ;if msb equal then check lsb
nochk   
		btfss   STATUS,C	;C set if c>a
		goto    nogo
		movfw   ACC_a_0	      	;c-a into c
		subwf   ACC_c_0,f
		btfss   STATUS,C
		decf    ACC_c_1,f
		movfw   ACC_a_1
		subwf   ACC_c_1,f
		bsf     STATUS,C	;shift a 1 into b (result)
nogo    
		rlf     ACC_b_0,f
		rlf     ACC_b_1,f
		rlf	ACC_b_2,f
		decfsz  Temp1,f         ;loop untill all bits checked
		goto    dloop
		return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;		Modified from AN526
;*******************************************************************
;                    Double Precision Multiplication
;
;               ( Optimized for Code Size : Looped Code )
;
;*******************************************************************;
;   Multiplication : ACCb(16 bits) * ACCa(16 bits) -> ACCb,ACCc ( 32 bits )
;      (a) Load the 1st operand in location ACC_a_0 & ACC_a_1 ( 16 bits )
;      (b) Load the 2nd operand in location ACC_b_0 & ACC_b_1 ( 16 bits )
;      (c) CALL D_mpy
;      (d) The 32 bit result is in location ( ACC_b_1,ACC_b_0,ACC_c_1,ACC_c_0 )
;
;   Performance :
;               Program Memory  :       033
;               Clock Cycles    :       333
;
;       Note : The above timing is the worst case timing, when the
;               register ACCb = FFFF. The speed may be improved if
;               the register ACCb contains a number ( out of the two
;               numbers ) with less number of 1s.
;               The performance specs are for Unsigned arithmetic ( i.e,
;               with "SIGNED equ  FALSE ").
;
;               The performance specs are for Unsigned arithmetic ( i.e,
;               with "SIGNED equ  FALSE ").
;
;
;       Program:          DBL_MPYS.ASM 
;       Revision Date:   
;                         12-12-95      Compatibility with MPASMWIN 1.30
;
;*******************************************************************;
;         Double Precision Addition ( ACCb + ACCa -> ACCb )
;
D_add   bcf	mult_carry	;Clear Temp_1 Carry bit
	movf    ACC_a_0,w        ; Addition ( ACCb + ACCa -> ACCb )
	addwf   ACC_b_0, F       ;add lsb
	movlw	.1
	btfsc   STATUS,C		;add in carry
 	addwf	ACC_b_1, F
	btfsc	STATUS,C
	bsf	mult_carry	
	movf    ACC_a_1,w
	addwf   ACC_b_1, F         ;add msb
	btfsc	mult_carry
	bsf	STATUS,C
	retlw   0
;*******************************************************************
;               Double Precision Multiply ( 16x16 -> 32 )
;         ( ACCb*ACCa -> ACCb,ACCc ) : 32 bit output with high word
;  in ACCb ( ACC_b_1,ACC_b_0 ) and low word in ACCc ( ACC_c_1,ACC_c_0 ).
;
D_mpy                           ;results in ACCb(16 msb's) and ACCc(16 lsb's)
;
	call    setup
mloop   rrf     ACC_d_1, F       ;rotate d right
	rrf     ACC_d_0, F
	btfsc   STATUS,C    	;need to add?
	call    D_add
	rrf     ACC_b_1, F
	rrf     ACC_b_0, F
	rrf     ACC_c_1, F
	rrf     ACC_c_0, F
	decfsz  Temp1, F        ;loop until all bits checked
	goto    mloop
;
	retlw   0
;*******************************************************************
;
setup   movlw   .16             ; for 16 shifts
	movwf   Temp1
	movf    ACC_b_1,w          ;move ACCb to ACCd
	movwf   ACC_d_1
	movf    ACC_b_0,w
	movwf   ACC_d_0
	clrf    ACC_b_1
	clrf    ACC_b_0
	retlw   0
;
;*******************************************************************
;
neg_A   comf    ACC_a_0, F       ; negate ACCa ( -ACCa -> ACCa )
	incf    ACC_a_0, F
	btfsc   STATUS,Z
	decf    ACC_a_1, F
	comf    ACC_a_1, F
	retlw   0
;
        include "lcd_4bit.inc"

	END